#include "sps2util_Godai.h"
#include <sps2lib.h>
#include <linux/ps2/dev.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>
#include "DJR_VsyncIntHandle.h"
#include "DJR_Mixer.h"
#include "DJR_SimpleTexMngr.h"
#include "DJR_Model.h"
#include "UsefulMacros.h"
#include "DJR_Visuals.h"
#include "DJR_PadManager.h"

int _uField = 0;
int _iEventFD = -1;
int _iSPS2Device = -1;
unsigned char iBGColor = 0;

/****************************************************/
void _VsyncHandler( int iSigNum )
{
  // 60 vsyncs per second, but we only render at 30fps
  _uField ^= 1;
  ++iBGColor % 256;

  if( _uField )
  {
    sps2UScreenSwap_NoVsyncWait( );
    RenderBackgroundVisuals( );
  }

  else
  {
    RenderRecords( );
    RenderMixer( );
  }
}

/******************************************************/
Bool InstallVsyncInterruptHandler( int iSPS2Device )
{
  _uField = 0;
  _iSPS2Device = iSPS2Device;

  _iEventFD = open( PS2_DEV_EVENT, O_RDWR);
  if( _iEventFD < 0 )
  {
    printf( "\n failed to open PS2_DEV_EVENT\n" );
    return FALSE;
  }

  // enable the event
  if( ioctl( _iEventFD, PS2IOC_ENABLEEVENT, PS2EV_VSYNC ) )
  {
    printf( "\nfailed to enable vsync event\n" );
    return FALSE;
  }

  if( ioctl( _iEventFD, PS2IOC_SETSIGNAL, SIGUSR1 ) )
  {
    printf( "\nfailed to set signal for event\n" );
    return FALSE;
  }

  // install the handler
  signal( SIGUSR1, _VsyncHandler );

  _iSPS2Device = iSPS2Device;

  InitVisuals( );

  return TRUE;
}

void RemoveVsyncInterruptHandler( void )
{
  signal( SIGUSR1, SIG_DFL );
  close( _iEventFD );
}
